﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;
using FTDI.D2XX.Device;
using Windows.Storage;
using Windows.UI;



namespace DeviceWatcher
{
    
    class FTApp
    {
       uint index;
        enum shapesState: int
        {                  
            Cal,            
            Sensors,
            Circles,
            Lines,
            Rectangles,
            Edge,
            Gradient,           
            Gauge,
            Bitmap,          
            Button,
            calWait,
            Idle
        }

        CoPro eve;
        Sensors  colProxSen;
        

        public  FTApp()
        {
           
        }


         
        async public Task Configure(FTD2xxDevice  device)
        {
            eve = new CoPro();
            await eve.Configure(device);            
            colProxSen = new Sensors();
            await colProxSen.SensorChannelConfig();
        }

        private void DLPre()
        {
            eve.PushCmd(new CoPro.Dlstart());
            eve.PushCmd(new EveDL.ClearColourRGB(0x00, 0x00, 0x00));
            eve.PushCmd(new EveDL.Clear());
            eve.PushCmd(new EveDL.ColourRGB((byte)0x00, (byte)(0x00), (byte)(0x00)));
        }
        private void DLPost()
        {
            eve.PushCmd(new EveDL.Display());
            eve.PushCmd(new CoPro.Swap());
            eve.PushCmd(new CoPro.Flush());
        }
                 

        async public Task TaskLoop()
        {
            Proximity proximity = new Proximity(0,true);

            Color color = new Color();

            ushort prevProx = 0;

            //int calCount = 0;
            shapesState st = shapesState.Sensors;
            uint tagVal = 0;

            try
            {
                int stCount = 0;
                for (int loop = 0; true; loop++)
                {
                    index =(uint) loop;

                    proximity = await colProxSen.GetProximity();
                    color      = await colProxSen.GetColor();

#if true                            
                    Random rnd = new Random();
                    bool buttonDelay=false;
                    //tagVal = eve.ReadTag();
                    //if (tagVal > 0 && tagVal <= (byte) shapesState.Idle) // Tag selects the state...
                    //    st = (shapesState)tagVal;
                    //else if (tagVal == 255)
                     //   st = shapesState.Button;

                    switch (st)
                        {
                            case shapesState.Cal:
                                DoCal(0);
                                st = shapesState.calWait;
                                Debug.WriteLine("Cal: ");
                                break;
                            case shapesState.calWait:
                                //await Task.Delay(10000);
                                Debug.WriteLine("Wait Cal: ");
                                while (! await eve.IsQueueEmpty())
                                {
                                   // await Task.Delay(1);
                                }         
                                                                        

                                st = shapesState.Button;
                                break;

                            case shapesState.Idle:
                                int count = eve.CmdQueueCount();
                                if ( count > 25)                                            
                                {
                                    await Task.Delay(1000);
                                    st = shapesState.Idle;
                                    Debug.WriteLine("Idleing Pipe full: {0}.", count);
                                    break;
                                }
                                await Task.Delay(1000);
                                st = shapesState.Lines;
                                Debug.WriteLine("Idle Pipe: {0}.", count);
                                break;
                            case shapesState.Circles:
                                DoCircles(10);
                                if (stCount++ > 10)
                                {
                                    stCount = 0;
                                    st = shapesState.Circles;
                                }
                                //if (tagVal == 0xff)
                                //    st = shapesState.Button;
                                break;
                            case shapesState.Lines:
                                DoLines(10);
                                if (stCount++ > 10)
                                {
                                    stCount = 0;
                                    st = shapesState.Rectangles;
                                }
                                //if (tagVal == 0xff)
                                //    st = shapesState.Button;
                                break;

                            case shapesState.Rectangles:
                                DoRect(10);
                                if (stCount++ > 10)
                                {
                                    stCount = 0;
                                    st = shapesState.Edge;
                                }
                                //if (tagVal == 0xff)
                                //    st = shapesState.Button;
                                break;
                            case shapesState.Edge:
                                DoEdge(10);
                                if (stCount++ > 10)
                                {
                                    stCount = 0;
                                    st = shapesState.Gradient;
                                }

                                break;

                            case shapesState.Gradient:
                                DoGrad(10);

                                break;
                            case shapesState.Button:
                                DoButton(5);
                                buttonDelay = true;

                                break;
                            case shapesState.Gauge:
                                DoGauge(stCount%35);
                                buttonDelay = false;
                                if (stCount++ > 100)
                                {
                                    stCount = 0;
                                    st = shapesState.Bitmap;
                                    buttonDelay = false;
                                }

                                break;

                            case shapesState.Bitmap:
                                DoBitmap(stCount );
                                buttonDelay = false;
                                if (stCount++ > 10)
                                {
                                    stCount = 0;
                                    st = shapesState.Sensors;
                                    buttonDelay = true;
                                }

                                break;


                            case shapesState.Sensors:

                                //if (prevProx != proximity.Prox)
                                    DoSensors(proximity, color);
                                // else
                                //     Debug.WriteLine("Blank!");
                                prevProx = proximity.Prox;

                                if (stCount++ > 10)
                                {
                                    stCount = 0;
                                    st = shapesState.Sensors;
                                    //buttonDelay = true;
                                }
                                break;

                        }

                        if ( buttonDelay )
                            await Task.Delay(1000);                                                         
#endif
                }
            }
            catch ( Exception ex)
            {
                Debug.WriteLine("Exception {0}", ex.Message);
            }
            Debug.WriteLine("dbg");
            return;
        }


        // push a Cal
        private void DoCal(int num)
        {
            DLPre();
            eve.PushCmd(new CoPro.Text(0, 40, 31, 0, "Calibrate"));
            eve.PushCmd(new CoPro.Calibrate());
            DLPost();
        }

        private void DoBitmap ( int num )
        {            
            string fileName = "ms-appx:///Assets/FTDILOGO.gif";
            Uri appUri = new Uri(fileName);//File name should be prefixed with 'ms-appx:///Assets/* 
            StorageFile logoFile = StorageFile.GetFileFromApplicationUriAsync(appUri).AsTask().ConfigureAwait(false).GetAwaiter().GetResult();
            DLPre();
            eve.PushCmd(new CoPro.BitmapSource(0));
            eve.PushCmd(new CoPro.BitmapLayout(BitMapFormat.RGB332, 386,150));
            eve.PushCmd(new CoPro.BitmapSize(BitmapFilter.Nearest, BitmapWrap.Border, BitmapWrap.Border, 386, 150));
            eve.PushCmd(new CoPro.Begin(DLprim.BITMAPS));
            eve.PushCmd(new CoPro.Vertex2II(50, 50, 0, 0));
            DLPost();
        }


        // push a gauge
        private void DoGauge(int num)
        {
            DLPre();
            eve.PushCmd(new CoPro.Gauge(160,150,50,0,5,4,(ushort)num,100));
            DLPost();
        }


        // push a Sensors page
        private void DoSensors(Proximity p, Color col)
        {
            Random rnd = new Random();
            ColourName colName;
           
            ushort num=69;
            const int proxBase = 0;
            const int proxMax = 65535- proxBase;
            //num = (ushort)((p.Prox- proxBase)*(100.0 / proxMax ));
            num = p.Prox;

            string proxTxt;
            ushort radius;


            DLPre();

            if (p.Valid)
            {
                radius = (ushort)(350 * Math.Log10(num));
                colName = colProxSen.GetColourName(col);

                eve.PushCmd(new CoPro.Gradient(240, 0, (uint)0x000000, 240, 320, (uint)0x808080));
                //proxTxt = "FTDI IoT:" + Convert.ToString(p.Prox);
                eve.PushCmd(new EveDL.ColourRGB((byte)0xFF, (byte)0xFF, (byte)0xFF));
                proxTxt = "FTDI IoT";// + Convert.ToString(num);
                eve.PushCmd(new CoPro.Text(220, 0,   31, 0, proxTxt));
                
                eve.PushCmd(new CoPro.Text(280, 90,  28, 0, "Red   "    + col.R.ToString()));
                eve.PushCmd(new CoPro.Text(280, 110, 28, 0, "Green "    + col.G.ToString()));
                eve.PushCmd(new CoPro.Text(280, 130, 28, 0, "Blue  "    + col.B.ToString()));
                //eve.PushCmd(new CoPro.Text(280, 150, 28, 0, "PRX "      + p.Prox.ToString()));
                if (radius > 500)
                    eve.PushCmd(new CoPro.Text(280, 180, 28, 0, "Hue:  " + colName.ToString()));
                else
                    eve.PushCmd(new CoPro.Text(280, 180, 28, 0, "Hue:  " ));

                ushort X0 = 120;
                ushort Y0 = 79;

                eve.PushCmd(new EveDL.Begin(DLprim.POINTS));               
                eve.PushCmd(new EveDL.ColourRGB((byte)0xFF, (byte)0xFF, (byte)0xFF));
                eve.PushCmd(new EveDL.PointSize((ushort)(1950)));
                eve.PushCmd(new EveDL.Vertex2II((ushort)X0, (ushort)Y0, 0, 0));
                eve.PushCmd(new EveDL.ColourRGB((byte)0x00, (byte)0x00, (byte)0x00));
                eve.PushCmd(new EveDL.PointSize((ushort)(1900)));
                eve.PushCmd(new EveDL.Vertex2II((ushort)X0, (ushort)Y0, 0, 0));
                if ( radius > 500)
                    eve.PushCmd(new EveDL.ColourRGB((byte)col.R, (byte)col.G, (byte)col.B));
                else
                    eve.PushCmd(new EveDL.ColourRGB((byte)0xff, (byte)0x00, (byte)0x00));
                eve.PushCmd(new EveDL.PointSize((ushort)(radius+100)));
                eve.PushCmd(new EveDL.Vertex2II((ushort)(X0), (ushort)(Y0), 0, 0));    
            }
            
            DLPost();
        }

        // push a Button
        private void DoButton(int num)
        {
            Random rnd = new Random();
            string[] words = { "Sensors","Circles", "Lines", "Rectangles", "Edge", "Gradient", "Gauge", "Bitmap" };
            DLPre();
            // Do six buttons
            eve.PushCmd(new EveDL.ColourRGB((byte)rnd.Next(255), (byte)rnd.Next(255), (byte)rnd.Next(255)));
            eve.PushCmd(new CoPro.TagMask(false));
            eve.PushCmd(new CoPro.TagMask(true));
            for ( int i =0; i < 6; i++ ) // 
            {                
                eve.PushCmd(new CoPro.Tag((byte)(i+1)));
                eve.PushCmd(new CoPro.Button((short)25, (short) ((i+1)*35), 100, 25, 26, 0, words[i]));
            }
            eve.PushCmd(new CoPro.TagMask(false));
            DLPost();
        }

        // push num random Gradients
        private void DoGrad(int num)
        {
            Random rnd = new Random();
            DLPre();
            eve.PushCmd(new CoPro.Gradient(0,0,(ushort)rnd.Next(0xffffff), 500, 300, (ushort)rnd.Next(0xffffff)));
            DLPost();
        }


        // push num random Edges
        private void DoEdge(int num)
        {
            Random rnd = new Random();
            DLPre();
       
            eve.PushCmd(new EveDL.Begin(DLprim.EDGE_STRIP_A));
            
            for (int i = 0; i < num; i++)
            {                
                eve.PushCmd(new EveDL.ColourRGB((byte)rnd.Next(255), (byte)rnd.Next(255), (byte)rnd.Next(255)));
                eve.PushCmd(new EveDL.PointSize((ushort)rnd.Next(500)));
                eve.PushCmd(new EveDL.Vertex2II((ushort)rnd.Next(512), (ushort)rnd.Next(340), 0, 0));
            }
            DLPost();
        }
        // push num random circles onto cmd
        private void DoCircles( int num)
        {
            Random rnd = new Random();
            DLPre();
         
            eve.PushCmd(new EveDL.Begin(DLprim.POINTS));
            
            for (int i = 0; i < num; i++)
            {
                //eve.PushCmd(new EveDL.Vertex2II(0x30, 0x30, 0, 0));
                eve.PushCmd(new EveDL.ColourRGB((byte)rnd.Next(255), (byte)rnd.Next(255), (byte)rnd.Next(255)));
                eve.PushCmd(new EveDL.PointSize((ushort)rnd.Next(500)));
                eve.PushCmd(new EveDL.Vertex2II((ushort)rnd.Next(512), (ushort)rnd.Next(340), 0, 0));                
            }
          
            DLPost();
        }
        // push num random lines onto cmd
    private void  DoLines(int num )
        {
            Random rnd = new Random();
            DLPre();
         
            
            eve.PushCmd(new EveDL.Begin(DLprim.LINES));
            
            for (int i = 0; i < num; i++)
            {
                //eve.PushCmd(new EveDL.Vertex2II(0x30, 0x30, 0, 0));
                eve.PushCmd(new EveDL.ColourRGB((byte)rnd.Next(255), (byte)rnd.Next(255), (byte)rnd.Next(255)));
                eve.PushCmd(new EveDL.PointSize((ushort)rnd.Next(750)));
                eve.PushCmd(new EveDL.Vertex2II((ushort)rnd.Next(512), (ushort)rnd.Next(340), 0, 0));
                eve.PushCmd(new EveDL.Vertex2II((ushort)rnd.Next(512), (ushort)rnd.Next(340), 0, 0));
            }
            
            DLPost();
        }

        private void DoRect(int num)
        {
            Random rnd = new Random();
            DLPre();
          
            eve.PushCmd(new EveDL.Begin(DLprim.RECTS));
            
            for (int i = 0; i < num; i++)
            {
                eve.PushCmd(new EveDL.ColourRGB((byte)rnd.Next(255), (byte)rnd.Next(255), (byte)rnd.Next(255)));
                eve.PushCmd(new EveDL.Vertex2II((ushort)rnd.Next(512), (ushort)rnd.Next(340), 0, 0));
                eve.PushCmd(new EveDL.Vertex2II((ushort)rnd.Next(512), (ushort)rnd.Next(340), 0, 0));
            }
            
            DLPost();
        }

        public void ClearToColour( byte red, byte green, byte blue )
        {
            DLPre();
            eve.PushCmd(new CoPro.Dlstart());
            eve.PushCmd(new EveDL.ClearColourRGB(red, green, blue));
            eve.PushCmd(new EveDL.Clear());
            eve.PushCmd(new EveDL.Display());
            eve.PushCmd(new CoPro.Swap());
            eve.PushCmd(new CoPro.Flush());
            DLPost();
            return;
        }
         
        public void SetText( string txt)
        {

            string now = DateTime.Now.ToString();

            DLPre();
            eve.PushCmd(new CoPro.Dlstart());
            eve.PushCmd(new EveDL.ClearColourRGB(0x00, 0x00,0xff ));
            eve.PushCmd(new EveDL.Clear());
            eve.PushCmd(new EveDL.ColourRGB(0xff, 0x00, 0xff));
            eve.PushCmd(new CoPro.Text(0, 19, 31, 0, txt));
            eve.PushCmd(new CoPro.Text(0, 60, 31, 0, now));
            eve.PushCmd(new EveDL.Display());
            eve.PushCmd(new CoPro.Swap());
            eve.PushCmd(new CoPro.Flush());
            DLPost();
            return;
        }


        void DoBack()
        {
            eve.PushCmd(new EveDL.ColourRGB(0xff, 0x00, 0x00));
            eve.PushCmd(new CoPro.Tag((byte)(255)));
            eve.PushCmd(new EveDL.Begin(DLprim.RECTS));
            eve.PushCmd(new EveDL.Vertex2II((ushort)0, (ushort)0, 0, 0));
            eve.PushCmd(new EveDL.Vertex2II((ushort)480, (ushort)272, 0, 0));            
        }
    }
}


